<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Input' => '\\StructType\\Input',
            'OutputTum2' => '\\StructType\\OutputTum2',
            'OutputDongu2' => '\\StructType\\OutputDongu2',
            'InputReferansNo' => '\\StructType\\InputReferansNo',
            'OutputTum' => '\\StructType\\OutputTum',
            'OutputDongu' => '\\StructType\\OutputDongu',
            'InputReferenceNumberEn' => '\\StructType\\InputReferenceNumberEn',
            'OutputAllEn' => '\\StructType\\OutputAllEn',
            'OutputArrayEn' => '\\StructType\\OutputArrayEn',
            'InputReferans' => '\\StructType\\InputReferans',
            'OutputTumReferans' => '\\StructType\\OutputTumReferans',
            'InputEn' => '\\StructType\\InputEn',
            'InputDropPoint' => '\\StructType\\InputDropPoint',
            'OutputDropPoint' => '\\StructType\\OutputDropPoint',
            'InputCity' => '\\StructType\\InputCity',
            'OutputCity' => '\\StructType\\OutputCity',
            'CityInformation' => '\\StructType\\CityInformation',
            'InputDropPointAll' => '\\StructType\\InputDropPointAll',
            'OutputDropPointAll' => '\\StructType\\OutputDropPointAll',
            'DropInfo' => '\\StructType\\DropInfo',
            'InputDistrict' => '\\StructType\\InputDistrict',
            'OutputDistrict' => '\\StructType\\OutputDistrict',
            'DistrictInformation' => '\\StructType\\DistrictInformation',
            'gonderiSorgu2' => '\\StructType\\GonderiSorgu2',
            'gonderiSorgu2Response' => '\\StructType\\GonderiSorgu2Response',
            'gonderiSorgu_referansNo' => '\\StructType\\GonderiSorgu_referansNo',
            'gonderiSorgu_referansNoResponse' => '\\StructType\\GonderiSorgu_referansNoResponse',
            'gonderiSorgu' => '\\StructType\\GonderiSorgu',
            'gonderiSorguResponse' => '\\StructType\\GonderiSorguResponse',
            'shipmentInquiry_ReferenceNumberEn' => '\\StructType\\ShipmentInquiry_ReferenceNumberEn',
            'shipmentInquiry_ReferenceNumberEnResponse' => '\\StructType\\ShipmentInquiry_ReferenceNumberEnResponse',
            'referansSorgu' => '\\StructType\\ReferansSorgu',
            'referansSorguResponse' => '\\StructType\\ReferansSorguResponse',
            'shipmentInquiryEn' => '\\StructType\\ShipmentInquiryEn',
            'shipmentInquiryEnResponse' => '\\StructType\\ShipmentInquiryEnResponse',
            'getDropPointInfo' => '\\StructType\\GetDropPointInfo',
            'getDropPointInfoResponse' => '\\StructType\\GetDropPointInfoResponse',
            'getCity' => '\\StructType\\GetCity',
            'getCityResponse' => '\\StructType\\GetCityResponse',
            'getAllDropPointInfo' => '\\StructType\\GetAllDropPointInfo',
            'getAllDropPointInfoResponse' => '\\StructType\\GetAllDropPointInfoResponse',
            'getDistrict' => '\\StructType\\GetDistrict',
            'getDistrictResponse' => '\\StructType\\GetDistrictResponse',
        );
    }
}
