<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InputDropPointAll StructType
 * @subpackage Structs
 */
class InputDropPointAll extends AbstractStructBase
{
    /**
     * The city_code
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $city_code;
    /**
     * The district_code
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $district_code;
    /**
     * The password
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $password;
    /**
     * The username
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $username;
    /**
     * Constructor method for InputDropPointAll
     * @uses InputDropPointAll::setCity_code()
     * @uses InputDropPointAll::setDistrict_code()
     * @uses InputDropPointAll::setPassword()
     * @uses InputDropPointAll::setUsername()
     * @param int $city_code
     * @param int $district_code
     * @param string $password
     * @param string $username
     */
    public function __construct($city_code = null, $district_code = null, $password = null, $username = null)
    {
        $this
            ->setCity_code($city_code)
            ->setDistrict_code($district_code)
            ->setPassword($password)
            ->setUsername($username);
    }
    /**
     * Get city_code value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getCity_code()
    {
        return isset($this->city_code) ? $this->city_code : null;
    }
    /**
     * Set city_code value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $city_code
     * @return \StructType\InputDropPointAll
     */
    public function setCity_code($city_code = null)
    {
        // validation for constraint: int
        if (!is_null($city_code) && !(is_int($city_code) || ctype_digit($city_code))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($city_code, true), gettype($city_code)), __LINE__);
        }
        if (is_null($city_code) || (is_array($city_code) && empty($city_code))) {
            unset($this->city_code);
        } else {
            $this->city_code = $city_code;
        }
        return $this;
    }
    /**
     * Get district_code value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getDistrict_code()
    {
        return isset($this->district_code) ? $this->district_code : null;
    }
    /**
     * Set district_code value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $district_code
     * @return \StructType\InputDropPointAll
     */
    public function setDistrict_code($district_code = null)
    {
        // validation for constraint: int
        if (!is_null($district_code) && !(is_int($district_code) || ctype_digit($district_code))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($district_code, true), gettype($district_code)), __LINE__);
        }
        if (is_null($district_code) || (is_array($district_code) && empty($district_code))) {
            unset($this->district_code);
        } else {
            $this->district_code = $district_code;
        }
        return $this;
    }
    /**
     * Get password value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPassword()
    {
        return isset($this->password) ? $this->password : null;
    }
    /**
     * Set password value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $password
     * @return \StructType\InputDropPointAll
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($password, true), gettype($password)), __LINE__);
        }
        if (is_null($password) || (is_array($password) && empty($password))) {
            unset($this->password);
        } else {
            $this->password = $password;
        }
        return $this;
    }
    /**
     * Get username value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUsername()
    {
        return isset($this->username) ? $this->username : null;
    }
    /**
     * Set username value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $username
     * @return \StructType\InputDropPointAll
     */
    public function setUsername($username = null)
    {
        // validation for constraint: string
        if (!is_null($username) && !is_string($username)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($username, true), gettype($username)), __LINE__);
        }
        if (is_null($username) || (is_array($username) && empty($username))) {
            unset($this->username);
        } else {
            $this->username = $username;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\InputDropPointAll
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
