<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OutputDropPointAll StructType
 * @subpackage Structs
 */
class OutputDropPointAll extends AbstractStructBase
{
    /**
     * The code
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $code;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $description;
    /**
     * The info
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DropInfo[]
     */
    public $info;
    /**
     * Constructor method for OutputDropPointAll
     * @uses OutputDropPointAll::setCode()
     * @uses OutputDropPointAll::setDescription()
     * @uses OutputDropPointAll::setInfo()
     * @param int $code
     * @param string $description
     * @param \StructType\DropInfo[] $info
     */
    public function __construct($code = null, $description = null, array $info = array())
    {
        $this
            ->setCode($code)
            ->setDescription($description)
            ->setInfo($info);
    }
    /**
     * Get code value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getCode()
    {
        return isset($this->code) ? $this->code : null;
    }
    /**
     * Set code value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $code
     * @return \StructType\OutputDropPointAll
     */
    public function setCode($code = null)
    {
        // validation for constraint: int
        if (!is_null($code) && !(is_int($code) || ctype_digit($code))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        if (is_null($code) || (is_array($code) && empty($code))) {
            unset($this->code);
        } else {
            $this->code = $code;
        }
        return $this;
    }
    /**
     * Get description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDescription()
    {
        return isset($this->description) ? $this->description : null;
    }
    /**
     * Set description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $description
     * @return \StructType\OutputDropPointAll
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->description);
        } else {
            $this->description = $description;
        }
        return $this;
    }
    /**
     * Get info value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DropInfo[]|null
     */
    public function getInfo()
    {
        return isset($this->info) ? $this->info : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInfoForArrayConstraintsFromSetInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $outputDropPointAllInfoItem) {
            // validation for constraint: itemType
            if (!$outputDropPointAllInfoItem instanceof \StructType\DropInfo) {
                $invalidValues[] = is_object($outputDropPointAllInfoItem) ? get_class($outputDropPointAllInfoItem) : sprintf('%s(%s)', gettype($outputDropPointAllInfoItem), var_export($outputDropPointAllInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The info property can only contain items of type \StructType\DropInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set info value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DropInfo[] $info
     * @return \StructType\OutputDropPointAll
     */
    public function setInfo(array $info = array())
    {
        // validation for constraint: array
        if ('' !== ($infoArrayErrorMessage = self::validateInfoForArrayConstraintsFromSetInfo($info))) {
            throw new \InvalidArgumentException($infoArrayErrorMessage, __LINE__);
        }
        if (is_null($info) || (is_array($info) && empty($info))) {
            unset($this->info);
        } else {
            $this->info = $info;
        }
        return $this;
    }
    /**
     * Add item to info value
     * @throws \InvalidArgumentException
     * @param \StructType\DropInfo $item
     * @return \StructType\OutputDropPointAll
     */
    public function addToInfo(\StructType\DropInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DropInfo) {
            throw new \InvalidArgumentException(sprintf('The info property can only contain items of type \StructType\DropInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->info[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OutputDropPointAll
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
