<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OutputTumReferans StructType
 * @subpackage Structs
 */
class OutputTumReferans extends AbstractStructBase
{
    /**
     * The barkodBilgi
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OutputTum[]
     */
    public $barkodBilgi;
    /**
     * The sonucAciklama
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $sonucAciklama;
    /**
     * The sonucKodu
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $sonucKodu;
    /**
     * Constructor method for OutputTumReferans
     * @uses OutputTumReferans::setBarkodBilgi()
     * @uses OutputTumReferans::setSonucAciklama()
     * @uses OutputTumReferans::setSonucKodu()
     * @param \StructType\OutputTum[] $barkodBilgi
     * @param string $sonucAciklama
     * @param int $sonucKodu
     */
    public function __construct(array $barkodBilgi = array(), $sonucAciklama = null, $sonucKodu = null)
    {
        $this
            ->setBarkodBilgi($barkodBilgi)
            ->setSonucAciklama($sonucAciklama)
            ->setSonucKodu($sonucKodu);
    }
    /**
     * Get barkodBilgi value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OutputTum[]|null
     */
    public function getBarkodBilgi()
    {
        return isset($this->barkodBilgi) ? $this->barkodBilgi : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBarkodBilgi method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBarkodBilgi method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBarkodBilgiForArrayConstraintsFromSetBarkodBilgi(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $outputTumReferansBarkodBilgiItem) {
            // validation for constraint: itemType
            if (!$outputTumReferansBarkodBilgiItem instanceof \StructType\OutputTum) {
                $invalidValues[] = is_object($outputTumReferansBarkodBilgiItem) ? get_class($outputTumReferansBarkodBilgiItem) : sprintf('%s(%s)', gettype($outputTumReferansBarkodBilgiItem), var_export($outputTumReferansBarkodBilgiItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The barkodBilgi property can only contain items of type \StructType\OutputTum, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set barkodBilgi value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OutputTum[] $barkodBilgi
     * @return \StructType\OutputTumReferans
     */
    public function setBarkodBilgi(array $barkodBilgi = array())
    {
        // validation for constraint: array
        if ('' !== ($barkodBilgiArrayErrorMessage = self::validateBarkodBilgiForArrayConstraintsFromSetBarkodBilgi($barkodBilgi))) {
            throw new \InvalidArgumentException($barkodBilgiArrayErrorMessage, __LINE__);
        }
        if (is_null($barkodBilgi) || (is_array($barkodBilgi) && empty($barkodBilgi))) {
            unset($this->barkodBilgi);
        } else {
            $this->barkodBilgi = $barkodBilgi;
        }
        return $this;
    }
    /**
     * Add item to barkodBilgi value
     * @throws \InvalidArgumentException
     * @param \StructType\OutputTum $item
     * @return \StructType\OutputTumReferans
     */
    public function addToBarkodBilgi(\StructType\OutputTum $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OutputTum) {
            throw new \InvalidArgumentException(sprintf('The barkodBilgi property can only contain items of type \StructType\OutputTum, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->barkodBilgi[] = $item;
        return $this;
    }
    /**
     * Get sonucAciklama value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSonucAciklama()
    {
        return isset($this->sonucAciklama) ? $this->sonucAciklama : null;
    }
    /**
     * Set sonucAciklama value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sonucAciklama
     * @return \StructType\OutputTumReferans
     */
    public function setSonucAciklama($sonucAciklama = null)
    {
        // validation for constraint: string
        if (!is_null($sonucAciklama) && !is_string($sonucAciklama)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sonucAciklama, true), gettype($sonucAciklama)), __LINE__);
        }
        if (is_null($sonucAciklama) || (is_array($sonucAciklama) && empty($sonucAciklama))) {
            unset($this->sonucAciklama);
        } else {
            $this->sonucAciklama = $sonucAciklama;
        }
        return $this;
    }
    /**
     * Get sonucKodu value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getSonucKodu()
    {
        return isset($this->sonucKodu) ? $this->sonucKodu : null;
    }
    /**
     * Set sonucKodu value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $sonucKodu
     * @return \StructType\OutputTumReferans
     */
    public function setSonucKodu($sonucKodu = null)
    {
        // validation for constraint: int
        if (!is_null($sonucKodu) && !(is_int($sonucKodu) || ctype_digit($sonucKodu))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sonucKodu, true), gettype($sonucKodu)), __LINE__);
        }
        if (is_null($sonucKodu) || (is_array($sonucKodu) && empty($sonucKodu))) {
            unset($this->sonucKodu);
        } else {
            $this->sonucKodu = $sonucKodu;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OutputTumReferans
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
